//"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
//  Cloak.cpp
//
//  The actually cloak going over UOX, handles thread controll, piping etc.
//
//
//"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
//  cluox - Windows-GUI wrapper for UOX.
//  Copyright (C) 2000, 2001 Axel Kittenberger
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""

#ifndef __CLOAK_H__
#define __CLOAK_H__

class ConsoleView;
class MainFrame;
#include <afxmt.h>

class Cloak {
  private :
    static ConsoleView *consoleView;
    static MainFrame   *mainFrame;
    static unsigned long __stdcall scoop_start(void *parm);
    static unsigned long __stdcall gurdian_start(void *parm);
    static HANDLE hpipe_out_read;
    static HANDLE hpipe_out_write;
    static HANDLE hpipe_in_read;
    static HANDLE hpipe_in_write;
    static HANDLE huox;
    static bool shutdown_request;
    //CMutex mutex_buffer;
    static time_t shutdown_start;
    static time_t watchdog_start;
    static void check_watchdog();
    static bool first_active;

  public :
    void static initalize(ConsoleView *s_consoleView, MainFrame *s_mainFrame);
    static void finalize();  
    static void terminate_uox();

    static bool cloak_on;
    static bool cloak_done;
    static void restart();
    static void shutdown();

    static bool probe_uox_server_port();
    static bool probe_uox_client_port();
    static void terminate_cloak();

    static bool scoop_running;
    static bool scoop_done;
    static unsigned long scoop_id;

    static bool gurdian_running;
    static unsigned long gurdian_id;

    static void execute();
    static void feed_char(unsigned char ch);

    // these values can be modified through the watchdog dialog
    static int  check_delay;
    static int  retries;
    static int  first_check;
    static int  response_time;
    static int  retry_delay;
    static bool watchdog_enable;

	// Additions made by ShadowBranch - July 17, 2005
	static bool logtofile_enabled;
	static CString logfile_directory;
	static CString uox_directory;
	static bool autostart_server;
	static bool server_is_running;
	static bool secure_mode;
	static void startserver();
	static void reloadini();
	static void reloadaccounts();
	static void reloadregions();
	static void reloadspawnregions();
	static void reloadspells();
	static void reloaddfnfiles();
	static void reloadjsfiles();
	static void secureconsole();
	static void commandlist();
	static void configuration();
	static void consolebroadcast();
	static void save_accounts();
	static void save_world();
	static void maintain_performance();
	static void maintain_characters();
	static void maintain_memory();
	static void maintain_shutdown();
	static void maintain_lookups();
	static void maintain_maps();
	static void network_disconzero();
	static void network_disconall();
	static void network_socketlogging();
};

#endif