//"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
//  ConBuffer.h
//
//  keeps the screen buffer.
//
//
//"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
//  cluox - Windows-GUI wrapper for UOX.
//  Copyright (C) 2000, 2001 Axel Kittenberger
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""

#ifndef __CON_BUFFER_H__
#define __CON_BUFFER_H__

#include <stdio.h>
#include <afxmt.h>
#include "default.h"

class Cloak;
class MainFrame;

#define WHITE   0xffffff
#define BLUE    0xffA000
#define RED     0x0000ff

class ConBuffer
{
  private :
    unsigned int min;
    unsigned int max;

    char screen[MAX_CONSOLE_LINES][81];
    unsigned int color[MAX_CONSOLE_LINES][81];

  public :
    ConBuffer();
    const char *getline(unsigned int y);
    const unsigned int *getcolor(unsigned int y);

    void setchar(unsigned int x, unsigned int y, char ch, unsigned int color);
    void newline(); // expands the buffer by 1 line
    unsigned int size();

    inline unsigned int getmin() {return min;}
    inline unsigned int getmax() {return max;}
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}

#endif
