/////////////////////////////////////////////////
// Options - OptionsDlg.cpp
// Contains the constructs for all the extra options
//    in the program
// Daniel Moree (ShadowBranch) - July 17, 2005
/////////////////////////////////////////////////
#include "stdafx.h"
#include "cluox.h"
#include "Cloak.h"
#include "Options.h"

OptionsDlg::OptionsDlg() : CDialog(OptionsDlg::IDD)
{
	//{{AFX_DATA_INIT(COptionsDlg)
	logging_active = FALSE;
	log_directory = _T("");
	uox_directory = _T("");
	autostart_server = FALSE;
	//}}AFX_DATA_INIT
}

void OptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsDlg)
	DDX_Text(pDX, IDC_LOGDIRECTORY, log_directory);
	DDX_Text(pDX, IDC_UOXDIRECTORY, uox_directory);
	DDX_Check(pDX, IDC_LOGFILE_ENABLED, logging_active);
	DDX_Check(pDX, IDC_AUTOSTART_SERVER, autostart_server);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(OptionsDlg, CDialog)
	//{{AFX_MSG_MAP(COptionsDlg)
		
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL OptionsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	logging_active = Cloak::logtofile_enabled;
	log_directory = Cloak::logfile_directory;
	uox_directory = Cloak::uox_directory;
	autostart_server = Cloak::autostart_server;

	UpdateData(false);
	return TRUE;
}
