// WatchdogDlg.cpp : implementation file
//

#include "stdafx.h"
#include "cluox.h"
#include "WatchdogDlg.h"
#include "Cloak.h"
#include "default.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// WatchdogDlg dialog


WatchdogDlg::WatchdogDlg(CWnd* pParent /*=NULL*/)
	: CDialog(WatchdogDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(WatchdogDlg)
	text_delay_watchdog = _T("");
	val_delay_watchdog = 0;
	text_first_delay = _T("");
	text_respond_time = _T("");
	text_retries = _T("");
	val_delay_retry = 0;
	val_first_delay = 0;
	val_respond_time = 0;
	val_retries = 0;
	text_delay_retry = _T("");
	val_watchdog_enable = FALSE;
	//}}AFX_DATA_INIT
}


void WatchdogDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(WatchdogDlg)
	DDX_Control(pDX, IDC_EDIT_DELAY_RETRY, edit_delay_retry);
	DDX_Control(pDX, IDC_SLIDER_DELAY_WATCHDOG, slide_delay_watchdog);
	DDX_Control(pDX, IDC_SLIDER_RETRIES, slide_retries);
	DDX_Control(pDX, IDC_SLIDER_RESPOND_TIME, slide_respond_time);
	DDX_Control(pDX, IDC_SLIDER_FIRST_DELAY, slide_first_delay);
	DDX_Control(pDX, IDC_SLIDER_DELAY_RETRY, slide_delay_retry);
	DDX_Control(pDX, IDC_EDIT_RETRIES, edit_retries);
	DDX_Control(pDX, IDC_EDIT_RESPOND_TIME, edit_respond_time);
	DDX_Control(pDX, IDC_EDIT_FIRST_DELAY, edit_first_delay);
	DDX_Control(pDX, IDC_EDIT_DELAY_WATCHDOG, edit_delay_watchdog);
	DDX_Text(pDX, IDC_EDIT_DELAY_WATCHDOG, text_delay_watchdog);
	DDX_Slider(pDX, IDC_SLIDER_DELAY_WATCHDOG, val_delay_watchdog);
	DDX_Text(pDX, IDC_EDIT_FIRST_DELAY, text_first_delay);
	DDX_Text(pDX, IDC_EDIT_RESPOND_TIME, text_respond_time);
	DDX_Text(pDX, IDC_EDIT_RETRIES, text_retries);
	DDX_Slider(pDX, IDC_SLIDER_DELAY_RETRY, val_delay_retry);
	DDX_Slider(pDX, IDC_SLIDER_FIRST_DELAY, val_first_delay);
	DDX_Slider(pDX, IDC_SLIDER_RESPOND_TIME, val_respond_time);
	DDX_Slider(pDX, IDC_SLIDER_RETRIES, val_retries);
	DDX_Text(pDX, IDC_EDIT_DELAY_RETRY, text_delay_retry);
	DDX_Check(pDX, IDC_WATCHDOG_ENABLE, val_watchdog_enable);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(WatchdogDlg, CDialog)
	//{{AFX_MSG_MAP(WatchdogDlg)
	ON_WM_HSCROLL()
	ON_EN_CHANGE(IDC_EDIT_DELAY_WATCHDOG, OnChangeEditDelayWatchdog)
	ON_EN_CHANGE(IDC_EDIT_DELAY_RETRY, OnChangeEditDelayRetry)
	ON_EN_CHANGE(IDC_EDIT_FIRST_DELAY, OnChangeEditFirstDelay)
	ON_EN_CHANGE(IDC_EDIT_RESPOND_TIME, OnChangeEditRespondTime)
	ON_EN_CHANGE(IDC_EDIT_RETRIES, OnChangeEditRetries)
	ON_BN_CLICKED(IDC_DEFAULTS, OnDefaults)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// WatchdogDlg message handlers



void WatchdogDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
  // The sliders send messages like this.	
  CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
  if (pScrollBar == (CScrollBar *) &slide_delay_watchdog) {
    UpdateData(true);
    text_delay_watchdog.Format("%d", val_delay_watchdog);
    UpdateData(false);
  }
  if (pScrollBar == (CScrollBar *) &slide_delay_retry) {
    UpdateData(true);
    text_delay_retry.Format("%d", val_delay_retry);
    UpdateData(false);
  }
  if (pScrollBar == (CScrollBar *) &slide_first_delay) {
    UpdateData(true);
    text_first_delay.Format("%d", val_first_delay);
    UpdateData(false);
  }
  if (pScrollBar == (CScrollBar *) &slide_retries) {
    UpdateData(true);
    text_retries.Format("%d", val_retries);
    UpdateData(false);
  }
  if (pScrollBar == (CScrollBar *) &slide_respond_time) {
    UpdateData(true);
    text_respond_time.Format("%d", val_respond_time);
    UpdateData(false);
  }
}


BOOL WatchdogDlg::OnInitDialog() 
{
  CDialog::OnInitDialog();
	
  slide_delay_watchdog.SetRangeMin(1);
  slide_delay_watchdog.SetRangeMax(180);

  slide_retries.SetRangeMin(1);
  slide_retries.SetRangeMax(20);

  slide_delay_retry.SetRangeMin(1);
  slide_delay_retry.SetRangeMax(300);

  slide_first_delay.SetRangeMin(0);
  slide_first_delay.SetRangeMax(20);

  slide_respond_time.SetRangeMin(1);
  slide_respond_time.SetRangeMax(60);

  text_delay_watchdog.Format("%d", Cloak::check_delay);
  text_retries.Format("%d", Cloak::retries);
  text_delay_retry.Format("%d", Cloak::retry_delay);
  text_first_delay.Format("%d", Cloak::first_check);
  text_respond_time.Format("%d", Cloak::response_time);
  
  val_delay_watchdog = Cloak::check_delay;
  val_retries        = Cloak::retries;
  val_delay_retry    = Cloak::retry_delay;
  val_first_delay    = Cloak::first_check;
  val_respond_time   = Cloak::response_time;
  val_watchdog_enable = Cloak::watchdog_enable;

  UpdateData(false);	
  return TRUE;  
}

void WatchdogDlg::OnChangeEditDelayWatchdog() 
{
  UpdateData(true);
  val_delay_watchdog = atoi(text_delay_watchdog);
  UpdateData(false);	
  UpdateData(true);
  text_delay_watchdog.Format("%d", val_delay_watchdog);
  UpdateData(false);	
}

void WatchdogDlg::OnChangeEditDelayRetry() 
{
  UpdateData(true);
  val_delay_retry = atoi(text_delay_retry);
  UpdateData(false);	
  UpdateData(true);
  text_delay_retry.Format("%d", val_delay_retry);
  UpdateData(false);	
}

void WatchdogDlg::OnChangeEditFirstDelay() 
{
  UpdateData(true);
  val_first_delay = atoi(text_first_delay);
  UpdateData(false);	
  UpdateData(true);
  text_first_delay.Format("%d", val_first_delay);
  UpdateData(false);	
}

void WatchdogDlg::OnChangeEditRespondTime() 
{
  UpdateData(true);
  val_respond_time = atoi(text_respond_time);
  UpdateData(false);	
  UpdateData(true);
  text_respond_time.Format("%d", val_respond_time);
  UpdateData(false);	
}

void WatchdogDlg::OnChangeEditRetries() 
{
  UpdateData(true);
  val_retries = atoi(text_retries);
  UpdateData(false);	
  UpdateData(true);
  text_retries.Format("%d", val_retries);
  UpdateData(false);	
}

void WatchdogDlg::OnDefaults() 
{
  text_delay_watchdog.Format("%d", DEFAULT_CHECK_DELAY);
  text_retries.Format("%d", DEFAULT_RETRIES);
  text_delay_retry.Format("%d", DEFAULT_RETRY_DELAY);
  text_first_delay.Format("%d", DEFAULT_FIRST_CHECK);
  text_respond_time.Format("%d", DEFAULT_RESPONSE_TIME);
  
  val_delay_watchdog = DEFAULT_CHECK_DELAY;
  val_retries        = DEFAULT_RETRIES;
  val_delay_retry    = DEFAULT_RETRY_DELAY;
  val_first_delay    = DEFAULT_FIRST_CHECK;
  val_respond_time   = DEFAULT_RESPONSE_TIME;

  val_watchdog_enable = true;

  UpdateData(false);	
}
