//"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
//  cluox.h
//
//  The main file
//
//
//"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
//  cluox - Windows-GUI wrapper for UOX.
//  Copyright (C) 2000, 2001 Axel Kittenberger
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""

#ifndef __CLUOX_H__
#define __CLUOX_H__

#define VERSION "1.4"

#ifndef __AFXWIN_H__
#  error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

class Application : public CWinApp
{
public:
	Application();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(Application)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

public:
	//{{AFX_MSG(Application)
	afx_msg void OnAppAbout();
	afx_msg void OnDlgOptions();
	afx_msg void OnStartServer();
	afx_msg void OnShutdownServer();
	afx_msg void OnReloadINI();
	afx_msg void OnReloadAccounts();
	afx_msg void OnReloadRegions();
	afx_msg void OnReloadSpawnRegions();
	afx_msg void OnReloadSpells();
	afx_msg void OnReloadDFNFiles();
	afx_msg void OnReloadJSFiles();
	afx_msg void OnSecureConsole();
	afx_msg void OnCommandList();
	afx_msg void OnConfiguration();
	afx_msg void OnConsoleBroadcast();
	afx_msg void OnSaveAccounts();
	afx_msg void OnSaveWorld();
	afx_msg void OnPerformance();
	afx_msg void OnCharcters();
	afx_msg void OnMemory();
	afx_msg void OnShutdown();
	afx_msg void OnDumpLookups();
	afx_msg void OnDisplayMaps();
	afx_msg void OnDisconnectZero();
	afx_msg void OnDisconnectAll();
	afx_msg void OnSocketLogging();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
#endif
